/*
  cototient_function.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <vector>
#include <libgen.h>
#include <gmpxx.h>

mpz_class cototient_function(mpz_class n)
{
  mpz_class f(2), r(n);
  const mpz_class c(n);

  for (; f <= n; mpz_nextprime(f.get_mpz_t(), f.get_mpz_t())) {
    if (n % f == 0) {
      r -= r / f;
      n /= f;
    }
    while (n % f == 0)
      n /= f;
  }
  return c - r;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-l lower] [-u upper]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n, l(1), u(10000);

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cerr, argc, argv);
    else if (std::string(argv[a]) == "-l" && a+1 < argc)
      l = argv[++a];
    else if (std::string(argv[a]) == "-u" && a+1 < argc)
      u = argv[++a];
    else
      break;

  for (n = l; n < u; ++n)
    std::cout << n << "\t" << cototient_function(n) << std::endl;

  return 0;
}
