/*
  integer_valued_polynomial_progression.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <vector>
#include <libgen.h>
#include <gmpxx.h>

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-c coefficient ...] [-k number]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n, k(10), i;
  std::vector<mpz_class> c;

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-c" && ++a < argc)
      for (; a<argc; ++a) {
	mpz_class n;
	try { n = mpz_class(argv[a]); }
	catch (...) { --a; break; }
	c.push_back(n);
      }
    else if (std::string(argv[a]) == "-k" && a+1 < argc)
      k = argv[++a];
    else
      break;

  for (i=0; i<k; ++i) {
    n = 0;
    for (size_t j=0; j<c.size(); j++) {
      mpz_class x;
      mpz_pow_ui(x.get_mpz_t(), i.get_mpz_t(), j);
      n += c[j]*x;
    }
    std::cout << n << std::endl;
  }  

  return 0;
}
