/*
  next_composite.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

inline
int mpz_probab_composite_p(const mpz_t n, int reps)
{
  return mpz_cmp_ui(n, 1) != 0 && !mpz_probab_prime_p(n, reps);
}
void mpz_nextcomposite(mpz_t rop, const mpz_t op)
{
  mpz_add_ui(rop, op, 1);
  for (; ; mpz_add_ui(rop, rop, 1))
    if (mpz_probab_composite_p(rop, 25))
      break;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a) {
    n = argv[a];
    if (argc > 2) std::cout << n << "\t";
    mpz_nextcomposite(n.get_mpz_t(), n.get_mpz_t());
    std::cout << n << std::endl;
  }

  return 0;
}
