/*
  primes_util-collate.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-l lower] [-u upper]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n, l(1), u(1000000000);

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-l" && a+1 < argc)
      l = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else if (std::string(argv[a]) == "-u" && a+1 < argc)
      u = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else
      break;

  isprime_bit_table_class isprime_bit_table(u);
  for (n = l; n < u; ++n) {
    mpz_class m(boost::lexical_cast<std::string>(n));
    if (!!isprime_bit_table[n] != !!mpz_probab_prime_p(m.get_mpz_t(), 25)) {
      std::cout << n << std::endl;
      return 1;
    }
  }

  return 0;
}
