/*
  primes.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-l lower] [-u upper]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n, l(1), u(100);

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-l" && a+1 < argc)
      l = argv[++a];
    else if (std::string(argv[a]) == "-u" && a+1 < argc)
      u = argv[++a];
    else
      break;

  mpz_nextprime(n.get_mpz_t(), l.get_mpz_t());
  for (; n < u; mpz_nextprime(n.get_mpz_t(), n.get_mpz_t()))
    std::cout << n << std::endl;

  return 0;
}
