/*
  primes_reverse.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

inline
void mpz_previousprime(mpz_t rop, const mpz_t op)
{
  mpz_sub_ui(rop, op, 1);
  for (; mpz_cmp_ui(rop, 0) > 0; mpz_sub_ui(rop, rop, 1))
    if (mpz_probab_prime_p(rop, 25))
      break;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-l lower] [-u upper]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n, l(1), u(100);

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-l" && a+1 < argc)
      l = argv[++a];
    else if (std::string(argv[a]) == "-u" && a+1 < argc)
      u = argv[++a];
    else
      break;

  mpz_previousprime(n.get_mpz_t(), u.get_mpz_t());
  for (; n > l; mpz_previousprime(n.get_mpz_t(), n.get_mpz_t()))
    std::cout << n << std::endl;

  return 0;
}
